/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/* Header file */
#ifdef VX
#include <vxWorks.h>
#include <taskLib.h>
#endif
#include <stdio.h>
#include "js-context.h"
#include "js-exceptionhandler.h"
#include "ewb-sys.h"
#include "ewb-sys-if.h"

#ifndef SHELL	/* '03.06.27 by S.Takaoka */
#include "ewb-dbg.h"
#endif

extern int ewbJsErrorDetails;
int ThrowCalltimes;

#if __x86_64
pthread_key_t   JSExceptionHandler::key;
#endif

/* Procedures */
JSExceptionHandler::JmpBuf *
JSExceptionHandler::_enterTry()
{
    return stack.getNext();
}
void
JSExceptionHandler::exitTry()
{
    stack.pop();
}
void
JSExceptionHandler::throwEx(JSContext* cx, JSException *ex)
{
#ifndef SHELL
    if(ThrowCalltimes==0){
        ThrowCalltimes=1;
        EwbNotifyError(EWB_ERROR_JS_THROW);
    }
#endif
    if (ex != NULL && stack.size() > 0) {
        JmpBuf buf;
      
#ifdef SHELL
        printf("#### Throw: %s ####\n", ex->toString(cx ) );
#else
        EwbSetLog("#### Throw: ####\n");
        EwbSetLog(ex->toString( cx ));
        if(ewbJsErrorDetails){
	    printf("<JavaScript>Throw: %s",ex->toStringWithSource( cx ));
        }
#endif
      
        buf = stack.pop();
#if __x86_64
        pthread_setspecific( key, ex );
        longjmp(buf.env, 1);
#else
        longjmp(buf.env, (int) ex);
#endif
    }
#ifdef SHELL
    printf("#### Illegal throw: %p %s ####\n", ex,
	   ex != NULL ? ex->toString( cx ): "xxx");
#else
    EwbSetLog("#### Illegal throw: ####\n");
    if( ex != NULL ) {
        EwbSetLog(ex->toString( cx ));
    }
#endif

#if defined(SUNOS5) || defined(LINUX)
    exit(1);
#elif defined(VX)
    taskSuspend( 0 );
#else
    ->
#endif
}

#if __x86_64
void
JSExceptionHandler::classInitialize()
{
    pthread_key_create(&key, NULL);
}
#endif
